//=============================================================================
// gameObtjec.h 
//
//Author: Doron Nussbaum (C) 2011 All Rights Reserved.
//-----------------------------------------------------
//
// Purpose: 
//--------------
// a. handles the common properties and functios of a game object 

//
// Description:
//--------------

//
//
// License
//--------------
//
// Code can be used for instructional and educational purposes and for assignments in the gaming courses at 
// the School of Compuer Science at Carleton University.
// Usage of code for other purposes is not allowed without a given permission by the author.
//
//
// Disclaimer
//--------------
//
// The code is provided as is without any warranty

//=============================================================================

#pragma once

#include "d3dx9.h"
#include "d3dx9math.h"



class gameObject
{
	// functions
public:
	gameObject(void);
	~gameObject(void);
	virtual int initGeom(void);
	virtual int render(int time);
	virtual int setScale(float scaleX, float scaleY, float scaleZ);
	virtual int setTranslation(float dx, float dy, float dz);
	virtual int setPosition(float x, float y, float z);
	virtual int setPosition(D3DXVECTOR3 pos);
	static int setd3dDev(IDirect3DDevice9 *d3dDev);  // setting the d3dDev global variable
	static int setViewMat(D3DXMATRIX * viewMat);
	static int setProjMat(D3DXMATRIX * projMat);


	//members
public:
	
	D3DXVECTOR3 mPosition;	// position of object
	D3DXVECTOR3 mDir;	// dirction of object
	float mRoll;			// angle of rotation around z-axis
	float mPitch;		// angle of rotation around x-axis
	float mYaw;			// angle of rotation around y-axis
	float mScaleX;		// scale in x
	float mScaleY;		// scale in y
	float mScaleZ;		// scale in z
	float mdx;			// translation along the x axis;
	float mdy;			// translation along the y axis;
	float mdz;			// translation along the z axis;

	static IDirect3DDevice9 *md3dDev;


	IDirect3DIndexBuffer9 *mIndBuf;
	IDirect3DVertexBuffer9 *mVtxBuf;

	static D3DXMATRIX viewMat;
	static D3DXMATRIX projMat;
};
