


//=============================================================================
// meshSurface.h 
//
//Author: Doron Nussbaum (C) 2011 All Rights Reserved.
//-----------------------------------------------------
//
// Purpose: 
//--------------
// a. demonstrates the creation of a surface and of vertex and index buffers
// b. demonstartes how to rpesent a surface 
//
//
// Description:
//--------------
//
//
//
// License
//--------------
//
// Code can be used for instructional and educational purposes and for assignments in the gaming courses at 
// the School of Compuer Science at Carleton University.
// Usage of code for other purposes is not allowed without a given permission by the author.
//
//
// Disclaimer
//--------------
//
// The code is provided as is without any warranty

//=============================================================================




#pragma once
#include "gameobject.h"
#include "d3dx9math.h"

#define NUSS_SHADERS 1


struct meshVertex {
	D3DXVECTOR3 pos;
    DWORD color;       // diffuse color
};


#ifndef NUSS_SHADERS
#define MESH_VERTEX_FVF (D3DFVF_XYZ | D3DFVF_DIFFUSE)
#endif





class meshSurface :
	public gameObject
{
public:
	meshSurface(void);
	~meshSurface(void);
	meshSurface(int numRows, int numCols, float dx, float dz);
	virtual int render(int time);
	int ShaderRender(int time);
	int TradtionalPipeRender(int time);
	int createSurface(int numRows, int numCols, float dx, float dz);
	int createGraphicsBuffers(void);
	int createVtxDescription(void);
	int setCentrePosition(D3DXVECTOR3 centrePos);
	int initEffect(void);



public:
	struct meshVertex *vtx;	// holds the vertices geometry
	long *ind;				// holds the topolcoy (indices) of the geometry
	int numVtx;
	int numQuads;
	int numTriangles;
	float dx;	// cell dimension along x axis
	float dz;	// cell dimension along z axis
		
	static IDirect3DVertexDeclaration9* meshDecl;

	int numRows;
	int numCols;
	int setScale(float scaleX, float scaleY, float scaleZ);
	ID3DXEffect *pMeshEffect;
	D3DXHANDLE hWorldViewProjMat;
	D3DXHANDLE hTime;
	D3DXHANDLE hCrater;
	D3DXHANDLE hHighWaves;
	D3DXHANDLE hFlatTechnique;
	D3DXHANDLE hCraterTechnique;
	D3DXHANDLE hWorldMat;
	D3DXHANDLE hViewMat;
	D3DXHANDLE hProjMat;
	D3DXHANDLE hTexture;
	int highWaves;

	D3DXVECTOR3 crater;


	IDirect3DTexture9 *mTexture;

	// creates a crater in the surface
	int setCraterPosition(float x, float y, float z);

	int updateCraterPosition(float dx, float dy, float dz);
};
