


// transformation matrix from the program
uniform extern float4x4 gWorldMat;	// world matrix
uniform extern float4x4 gViewMat;	// view matrix
uniform extern float4x4 gProjMat;	// projection matrix
uniform extern float time;		// game time
uniform extern float3 crater;		// crate centre

struct OutputVS
{
    float4 pos : POSITION0;
};



// vertex shader

struct OutputVS flatVS(float3 pos : POSITION0)
{
	// initalize the output
	struct OutputVS v = {0.0,0.0,0.0,0.0};
	
	
	// transform the vertex
	
	v.pos = float4(pos,1.0f);   //  convert to homogenous coord.
	
	// perform the transformations
	v.pos = mul(v.pos,gWorldMat); 
	v.pos = mul(v.pos,gViewMat);
	v.pos = mul(v.pos,gProjMat);

	// produce output
	return(v);
	
}

struct OutputVS craterVS(float3 pos : POSITION0)
{
	// initalize the output
	struct OutputVS v = {0.0,0.0,0.0,0.0};
	float d;		//distance
	
	
	// transform the vertex
	
	v.pos = float4(pos,1.0f);  //  convert to homogenous coord.
	
	d = sqrt(pow((crater.x - v.pos.x),2)+pow((crater.z - v.pos.z),2));
	
	// chnage the height in the y direction 
	// before the transformation take place
	v.pos.y = d/2; //v.pos.y + d/4;
	
	// perform the transformations
	v.pos = mul(v.pos,gWorldMat);
	v.pos = mul(v.pos,gViewMat);
	v.pos = mul(v.pos,gProjMat);

	// produce output
	return(v);
	
}



// Pixel Shader

float4 TransformFunPS() : COLOR
{
	float4 colour;
	colour.r = 1.0;
	colour.g = 1.0;
	colour.b = 0.0;
	colour.a = 1.0;
	return(colour);
}





technique FlatTechnique
{

	pass first {
		vertexshader = compile vs_2_0 flatVS();
		pixelshader = compile ps_2_0 TransformFunPS();
		
		FillMode = WireFrame;
		//FillMode = solid;
		
	}
}


technique CraterTechnique
{

	pass first {
		vertexshader = compile vs_2_0 craterVS();
		pixelshader = compile ps_2_0 TransformFunPS();
		
		FillMode = WireFrame;
		//FillMode = solid;
		
	}
}


	
	
	
